var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toESM = (module2, isNodeMode) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", !isNodeMode && module2 && module2.__esModule ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => ImagePresetsPlugin,
  formatFor: () => formatFor,
  mimeTypeFor: () => mimeTypeFor,
  widthPreset: () => widthPreset
});
var import_fs3 = require("fs");
var import_pathe2 = require("pathe");
var import_devalue = __toESM(require("@nuxt/devalue"), 1);

// src/utils.ts
var import_crypto = require("crypto");
var import_fs = require("fs");
var import_sharp = __toESM(require("sharp"), 1);
function loadImage(url) {
  return (0, import_sharp.default)(decodeURIComponent(parseURL(url).pathname));
}
function parseURL(rawURL) {
  return new URL(rawURL.replace(/#/g, "%23"), "file://");
}
function generateImageID(url, args) {
  return (0, import_crypto.createHash)("sha256").update(url).update(JSON.stringify(args)).digest("hex").slice(0, 8) + (args.format ? `.${args.format}` : "");
}
function getAssetHash(content) {
  return (0, import_crypto.createHash)("sha256").update(content).digest("hex").slice(0, 8);
}
async function exists(path) {
  return await import_fs.promises.access(path, import_fs.constants.F_OK).then(() => true, () => false);
}
function formatFor(image) {
  var _a;
  const format = (_a = image.options) == null ? void 0 : _a.formatOut;
  if (!format) {
    console.error("Could not infer image format for", image);
    throw new Error("Could not infer image format");
  }
  return format;
}
function mimeTypeFor(format) {
  if (format === "jpg")
    format = "jpeg";
  return `image/${format}`;
}

// src/api.ts
var import_fs2 = require("fs");
var import_pathe = require("pathe");
var import_debug = __toESM(require("debug"), 1);
var debug = {
  load: (0, import_debug.default)("image-presets:load"),
  write: (0, import_debug.default)("image-presets:write"),
  total: (0, import_debug.default)("image-presets:total")
};
var VIRTUAL_ID = "/@imagepresets/";
function createImageApi(config) {
  const requestedImagesById = {};
  const generatedImages = [];
  const imageHashesByFile = {};
  const imageFilenamesById = {};
  return {
    getImageById(id) {
      return requestedImagesById[id];
    },
    async waitForImages() {
      debug.total("%i image(s)", generatedImages.length);
      return await Promise.all(generatedImages);
    },
    async resolveImage(filename, params) {
      const presetName = params[config.urlParam];
      const preset = config.presets[presetName];
      debug.load("%O %s", params, filename);
      if (!preset)
        throw new Error(`vite-image-presets: Unknown image preset '${presetName}'`);
      let lastSrc;
      const imageResult = await Promise.all(preset.images.map(async (_a) => {
        var _b = _a, { srcset } = _b, source = __objRest(_b, ["srcset"]);
        return __spreadProps(__spreadValues({}, source), {
          srcset: (await Promise.all(srcset.map(async ({ condition, args, generate }) => [
            lastSrc = await getImageSrc(filename, args, generate),
            condition
          ].filter((x) => x).join(" ")))).join(", ")
        });
      }));
      const lastImage = imageResult[imageResult.length - 1];
      Object.assign(lastImage, preset.attrs);
      lastImage.src || (lastImage.src = lastSrc);
      return imageResult;
    }
  };
  async function getImageHash(filename) {
    return await (imageHashesByFile[filename] || (imageHashesByFile[filename] = loadImage(filename).toBuffer().then(getAssetHash)));
  }
  async function queueImageAndGetFilename(id, sourceFilename, image) {
    const base = (0, import_pathe.basename)(sourceFilename, (0, import_pathe.extname)(sourceFilename));
    const hash = getAssetHash(id + await getImageHash(sourceFilename));
    const format = formatFor(image);
    const filename = `${base}.${hash}.${format}`;
    generatedImages.push(writeImageFile(filename, image));
    return (0, import_pathe.join)(config.assetsDir, filename);
  }
  async function writeImageFile(filename, image) {
    const { cacheDir, assetsDir, outDir } = config;
    const cachedFilename = (0, import_pathe.join)(cacheDir, filename);
    const destFilename = (0, import_pathe.join)(outDir, assetsDir, filename);
    if (!await exists(cachedFilename)) {
      debug.write("%s", filename);
      await image.toFile(cachedFilename);
    }
    return {
      fileName: (0, import_pathe.relative)(config.outDir, destFilename),
      name: filename,
      source: await import_fs2.promises.readFile(cachedFilename),
      isAsset: true,
      type: "asset"
    };
  }
  async function getImageSrc(filename, args, generate) {
    filename = (0, import_pathe.resolve)(config.root, filename);
    const id = generateImageID(filename, args);
    const image = requestedImagesById[id] || (requestedImagesById[id] = generate(loadImage(filename), args));
    if (config.isBuild) {
      imageFilenamesById[id] || (imageFilenamesById[id] = queueImageAndGetFilename(id, filename, image));
      return config.base + await imageFilenamesById[id];
    }
    return VIRTUAL_ID + id;
  }
}

// src/presets.ts
function widthPreset(_a) {
  var _b = _a, { widths, formats } = _b, attrs = __objRest(_b, ["widths", "formats"]);
  return {
    attrs,
    images: Object.entries(formats).map(([format, formatOptions]) => ({
      type: mimeTypeFor(format),
      srcset: widths.map((width) => ({
        condition: `${width}w`,
        args: { format, width, formatOptions },
        generate: (image, { format: format2, formatOptions: formatOptions2, width: width2 }) => image.toFormat(format2, formatOptions2).resize({ width: width2, withoutEnlargement: true })
      }))
    }))
  };
}

// src/index.ts
function ImagePresetsPlugin(presets, options) {
  let api;
  let config;
  return {
    name: "image-presets",
    enforce: "pre",
    get api() {
      return api;
    },
    async configResolved({ base, command, root, build: { outDir, assetsDir } }) {
      config = __spreadValues({
        presets,
        urlParam: "preset",
        base,
        root,
        outDir: (0, import_pathe2.resolve)(root, outDir),
        assetsDir,
        cacheDir: (0, import_pathe2.join)(root, "node_modules", ".images"),
        isBuild: command === "build"
      }, options);
      api = createImageApi(config);
      if (config.isBuild)
        await import_fs3.promises.mkdir(config.cacheDir, { recursive: true });
    },
    async load(id) {
      if (!id.includes(config.urlParam))
        return;
      const { path, query } = parseId(id);
      if (!query.preset)
        return;
      const images = await api.resolveImage(path, query);
      return `export default ${(0, import_devalue.default)(images)}`;
    },
    configureServer(server) {
      server.middlewares.use((req, res, next) => {
        var _a;
        if ((_a = req.url) == null ? void 0 : _a.startsWith(VIRTUAL_ID)) {
          const [, id] = req.url.split(VIRTUAL_ID);
          const image = api.getImageById(id);
          if (!image)
            throw new Error(`vite-image-presets cannot find image with id "${id}" this is likely an internal error`);
          res.setHeader("Content-Type", `image/${formatFor(image)}`);
          res.setHeader("Cache-Control", "max-age=360000");
          return image.clone().on("error", (err) => console.error(err)).pipe(res);
        }
        next();
      });
    },
    async generateBundle(_, output) {
      const images = await api.waitForImages();
      images.forEach((asset) => {
        output[asset.fileName] = asset;
      });
    }
  };
}
function parseId(id) {
  const index = id.indexOf("?");
  if (index < 0)
    return { path: id, query: {} };
  const query = Object.fromEntries(new URLSearchParams(id.slice(index)));
  return { path: id.slice(0, index), query };
}
module.exports = __toCommonJS(src_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  formatFor,
  mimeTypeFor,
  widthPreset
});
